#
#   Image Processing
#   Pillow library
#
import PIL
from PIL import Image, ImageFilter, ImageOps, ImageColor, ImageEnhance

from lib import *

with Image.open("data/jagoda.jpg") as img:
    img.load()
    print( img.format )
    print( img.size )
    print( img.mode )

    #cropped_img = img.crop((300, 150, 700, 1000))
    #type(img)
#    img.show()

#    img_rot = img.rotate( 45, resample=Image.Resampling.BICUBIC )
    img = img.crop((450,280,1460,1050))
#    img = img.resize(( img.width // 4, img.height // 4))
#    img.show()
#    img = img.rotate( 45, expand=True )
#    img.show()
    #tile( img, img.convert("CMYK"), img.convert("L") ).show()


    # kanali
    red, green, blue = img.split()
    # tile( img, red, green, blue ).show()
    black = PIL.ImageChops.constant( red, 0 )
    # tile(
    #     img,
    #     Image.merge( "RGB", (red, black, black)),
    #     Image.merge( "RGB", (black, green, black)),
    #     Image.merge( "RGB", (black, black, blue))
    # ).show()
    
    # tile(
    #     img,
    #     Image.merge( "RGB", (red, green, black)),
    #     Image.merge( "RGB", (black, green, blue)),
    #     Image.merge( "RGB", (red, black, blue))
    # ).show()


    # filteri
    # tile(
    #     img,
    #     img.filter( ImageFilter.BLUR ),
    #     img.filter( ImageFilter.SMOOTH )
    # ).show( "Blur example" )

    # tile(
    #     img,
    #     img.filter( ImageFilter.BoxBlur(1) ),
    #     img.filter( ImageFilter.BoxBlur(3) ),
    #     img.filter( ImageFilter.BoxBlur(5) )
    # ).show( "BoxBlur example" )

    # tile(
    #     img,
    #     img.filter( ImageFilter.GaussianBlur(1) ),
    #     img.filter( ImageFilter.GaussianBlur(3) ),
    #     img.filter( ImageFilter.GaussianBlur(5) )
    # ).show( "GaussianBlur example" )

    # tile(
    #     img,
    #     img.filter( ImageFilter.BoxBlur(3) ),
    #     img.filter( ImageFilter.GaussianBlur(3) )
    # ).show( "GaussianBlur example" )

    # tile(
    #     img,
    #     img.filter( ImageFilter.SHARPEN ),
    #     img.filter( ImageFilter.UnsharpMask( 5, 50, 20 ) ),
    #     img.filter( ImageFilter.UnsharpMask( 5, 150, 10 ) )
    # ).show( "Sharp" )


    redonly = PIL.ImageChops.subtract( 
        red,
        PIL.ImageChops.blend( black, green, 0.8 )
    )
    redonly1 = threshold( redonly, 50 )
    redonly2 = redonly1.filter( ImageFilter.BLUR )
    redonly3 = threshold( redonly2, 50 )

    tile( 
        red,
        green,
        redonly,
        redonly1,
        redonly2,
        redonly3
    ).show()

    mask = redonly3
    cutoff = PIL.ImageChops.composite( img, black.convert("RGB"), mask )
    tile(
        img,
        red,
        mask,
        cutoff        
    ).show()

    cutoff = cutoff.resize( (img.width // 4, img.height // 4) )
    mask = mask.resize( (img.width // 4, img.height // 4) )

    cutoff.save( "data\\mala jagoda.jpg")
    mask.save( "data\\mala jagoda maska.jpg")

    for i in range( 10, 300, 50 ):
        img.paste( cutoff, (i,i//2), mask )
    img.show()



